;------------- ----------------------------------
Delit    equ 8  ;   
SEC      equ 9  ;    
MIN      equ 10 ;    
Chas     equ 11 ;    
SostKn   equ 12 ;    
NachStek equ 12 ;    

;------------- ---------------------------------
 ORG 0
  jmp init  ;    

;-------------   T0---------------------------
 ORG 0Bh
  mov TH0, #HIGH(-50000) ;   
  mov TL0, #LOW(-50000)  ;   
  reti

;------------- -------------------------
init:
  mov SP,#NachStek ;  
  call Timer0_Init ;  T0     50
  mov Delit,#20    ;     20 
  mov SEC,#60      ;      60
  mov MIN,#0       ;  
  mov Chas,#0      ;  

;-------------  --------------------
Begin:
  call OprosKnop   ; 
  call Indic       ;     
                   ;

  call CorrClock   ;  

  DJNZ Delit,Sleep ;   , 
    mov Delit,#20    ;     20 
    call Clock       ;    .

Sleep:
  orl PCON,#1;    
             ;     
  jmp begin  ;    
;-------------   --------------


;********************************************************************
;  
;********************************************************************
Clock:
  DJNZ SEC,ExitClock;   , 
    mov SEC,#60       ;      60
    Call IncMin
    JC ExitClock
      Call IncChas
ExitClock:
  ret



;********************************************************************
;    
;********************************************************************
IncMin:
  mov A,MIN               ;
  add A,#1                ;  
  DA A                    ;
  mov MIN,A               ;

  CJNE A,#60h,ExitIncMin  ;  60 ,
    mov MIN,#0              ;   
ExitIncMin:
  ret



;********************************************************************
;    
;********************************************************************
IncChas:
    mov A,Chas           ;
    add A,#1             ;  
    DA A                 ;
    mov Chas,A           ;

    CJNE A,#24h,ExitIncHr;  24 ,
      mov Chas,#0          ;   
ExitIncHr:
  ret







;********************************************************************
;  
;********************************************************************
OprosKnop:
  Mov A,SostKn   ;   

  Mov C,P1.7     ;   " "
  Mov ACC.0,C    ;   

  Mov C,P2.7     ;   " "
  Mov ACC.1,C    ;   

  Mov C,P3.7     ;   " "
  Mov ACC.2,C    ;   

  Mov SostKn,A   ;     
  ret




;********************************************************************
;   
;********************************************************************
CorrClock:
  Mov A,SostKn           ;   
  JB ACC.0,TstKnMin      ;   " ",
    Mov SEC,#0             ;   SEC
TstKnMin:
  Mov  A,Delit           ;  
  ANL  A,#3              ;  2,
  CJNE A,#2,ExitCorrClock;

    Mov A,SostKn           ;    .
    JB ACC.1,TstKnChs      ;   " ",
      Call IncMin            ;    
TstKnChs:
    JB ACC.2, ExitCorrClock;   " ",
      Call IncChas           ;    
ExitCorrClock:
  ret







;********************************************************************
;  
;********************************************************************
Indic:
  Mov A,MIN   ;   
  AnL A,#0Fh  ;  
  Call Decod  ;    
  Mov  P1,A   ;    P1  

  Mov A,MIN   ;   
  SWAP A      ;
  AnL A,#0Fh  ; 
  Call Decod  ;    
  Mov  P2,A   ;    P2  

  Mov A,Chas  ;   
  AnL A,#0Fh  ;  
  Call Decod  ;    
  Mov  P0,A   ;    P0  

  Mov A,Chas  ;   
  SWAP A      ;
  AnL A,#0Fh  ; 
  Call Decod  ;    
  Mov  P3,A   ;    P3  
Ret


;********************************************************************
;  
;********************************************************************
Decod:
  Mov DPTR,#TabSemiSeg ;    
  MovC A,@A+DPTR       ;    
  ret                  ;  

TabSemiSeg:
;     abcdefg
  DB 11111110b ; '0'       a
  DB 10110000b ; '1'    -------
  DB 11101101b ; '2'   |       |
  DB 11111001b ; '3'  f|       | b
  DB 10110011b ; '4'   |   g   | 
  DB 11011011b ; '5'    ------- 
  DB 11011111b ; '6'   |       |
  DB 11110000b ; '7'  e|       |c
  DB 11111111b ; '8'   |   d   |
  DB 11111011b ; '9'    -------

;********************************************************************
;   T0  50  
;********************************************************************
Timer0_Init:
    mov TMOD,#00000001b    ;  T0   
             ;||||||||      ,  T1 -   
             ;||||||++------  T0  
             ;||||||          
             ;|||||+--------  
             ;|||||         
             ;||||+---------   
             ;||||           INT0
             ;||++----------  T1 
             ;||             
             ;|+------------  
             ;|+------------
             ;+-------------  
             ;                INT1

;    50-  
;
  mov TH0, #HIGH(-50000) ;   
  mov TL0, #LOW(-50000)  ;   

  orl IE,#10000010b      ;   
  SetB TR0               ; 
  ret                    ;    

  end
